%Toolbox - Mapa de Kohonen unidimensional aplicado ao problema do caixeiro viajante
%Especificaes:
%   vizinhana - unidimensional em anel
%   nmero de neurnios - controlado dinamicamente por mecanismos de poda e insero
%   insero - 
%   poda - 

clear; close all;

%carrega as coordenadas das cidades
load dados.mat

%seleciona a instncia do caixeiro viajante
choice = menu('Escolha a instncia do caixeiro viajante','Berlin52','Inst. 1 (100 cidades) ','Inst. 2 (100 cidades)');
if choice == 1
    load berlin52
elseif choice == 2
    load inst100x100.mat
else
    load dados.mat;
end

%parmetros do SOM

%nmero inicial de neurnios
N = 10;
%nmero mximo de pocas do processo de auto-organizao
max_epoch = 500;
%nmero de pocas para zerar contador de vitrias e realizar etapas de poda e insero
PERIODO = 5;
%limiar de proximidade do neurnio vencedor ao padro
limiar = 0.01;
%taxa de aprendizado inicial
gama = 0.2;
%limiar (valor mnimo permitido) da taxa de aprendizado
limite_taxa = 0.01;
%raio (extenso) da vizinhana - no incio, os vizinhos (esquerdo e direito) so afetados de forma mais intensa; conforme o nmero de pocas aumenta, no teremos mais o ajuste
radius = 1;

%mapa auto-organizvel de Kohonen
[W,Index,Nf] = kohonen(X,N,gama,radius,limiar,limite_taxa,PERIODO,max_epoch);

%exibio de resultados
close(2); figure; plot_SOM(X,W,Nf);

%determinamos o percurso a ser realizado

%matriz com as distncias entre cada neurnio e cidade
mt = dist(W',X);
%matriz com as distncias entre as cidades
mx = dist(X', X); 
solucao = zeros(1,Nf); d = 0;
%encontramos a primeira cidade
[~,ind] = min(mt(1,:));
solucao(1) = ind;
for k=1:Nf-1
    %ind corresponde ao ndice da cidade representada pelo k-simo neurnio
    [~,ind] = min(mt(k+1,:));
    %montamos o percurso com a ordem das cidades
    solucao(k+1) = ind;
    %distncia entre as cidades  acumulada
    d = d + mx(solucao(k),solucao(k+1));
end
%inclumos tambm a distncia entre a 1a e a ltima cidade
d = d + mx(solucao(1),solucao(Nf));
title(['Configurao final dos neurnios(o) - Percurso total: ' num2str(d)]);
